Subject: bug#11365: 24.1.50; quitting gdb does not restore window configuration

From: martin rudalics <[email-masked]>
Date: Sat, 05 May 2012 11:42:04 +0200

> It is IMO wrong to do what Sam wants in gdb-delete-frame-or-window.

`gdb-delete-frame-or-window' is completely unrelated to this discussion.
I was mislead by its binding to `quit' in `gdb-breakpoints-mode-map' and
the fact that it could delete a window or frame.  Sorry for bringing it
in here in the first place.

 > That's because the restoration of the window configuration should be
 > done when GDB actually exits, not when the user _tells_ GDB to exit.
 > The function which handles the exit event is gdb-reset.

Indeed.  However, this presents a problem of orthogonality.  We would
have to save the window configuration in `gud-common-init' (in gud.el)
and restore it in `gdb-reset' (in gdb-mi.el) which looks pretty ugly to
me.  So `gud-common-init' would have to be aware of whether it's called
from `gdb' to avoid a leak.  Note that every stored window configuration
uses up memory and causes overhead for maintaining markers.

martin